var SemwidgQL;
(SemwidgQL = function() {
	var __instance;
	
	SemwidgQL = function SemwidgQL() {
		return __instance;
	};
	
	__instance = new SemwidgQL();
	__instance.constructor = SemwidgQL;

	__instance.instanceId = 'SWQL' + (new Date()).getTime();

	var scripts = document.getElementsByTagName('script');
    var src = scripts[scripts.length - 1].src;

    __instance.sourceLocation = src.split('?')[0].split('/').slice(0, -1).join('/') + '/';

	return __instance;
}());

SemwidgQL.getInstanceId = function() {
	return this.instanceId;
};

SemwidgQL.getSourceLocation = function() {
	return this.sourceLocation;
};

SemwidgQL.toSparql = function(semwidgQuery, prefixes, namedResources, throwExceptions) {

	SemwidgQL.setCurrentModel(null);

	if (semwidgQuery) {
		semwidgQuery = semwidgQuery.trim();
	}

	try {

		var cstream = new org.antlr.runtime.ANTLRStringStream(semwidgQuery);
		var lexer = new SemwidgQLLexer(cstream);
		var tstream = new org.antlr.runtime.CommonTokenStream(lexer);
		var parser = new SemwidgQLParser(tstream);
		
		var ast = parser.semwidg().tree;

		SemwidgQL.setCurrentModel(new SemwidgQL.Sparql.Model());
		SemwidgQL.getCurrentModel().setPrefixList(prefixes);
		SemwidgQL.getCurrentModel().setNamedResourceList(namedResources);

		var sparqlQueries = SemwidgQL.Sparql.createSparqlQueries(ast);

		return sparqlQueries;

	}catch(e) {
		if (throwExceptions) {
			throw e;
		}else {
			console.error(e);
		}
	}

	return null;
};

SemwidgQL.getNamedResources = function(semwidgQuery, throwExceptions) {
	
	var namedResources = new Array();

	if (semwidgQuery) {
		semwidgQuery = semwidgQuery.trim();
	}
	
	try {

		var cstream = new org.antlr.runtime.ANTLRStringStream(semwidgQuery);
		var lexer = new SemwidgQLLexer(cstream);
		var tstream = new org.antlr.runtime.CommonTokenStream(lexer);
		var parser = new SemwidgQLParser(tstream);
		
		var ast = parser.semwidg().tree;

		SemwidgQL.setCurrentModel(new SemwidgQL.Sparql.Model());
		
		var simpleQueries = SemwidgQL.Sparql.getSimpleQueries(ast);

		var resAndProp = new Array();
		for (var i = 0; i < simpleQueries.length; i++) {
			resAndProp = resAndProp.concat(SemwidgQL.Sparql.getUsedResourcesAndProperties(simpleQueries[i]));
		}

		for (var i = 0; i < resAndProp.length; i++) {
			if (resAndProp[i].getType() == 'NamedResource') {
				namedResources.push(resAndProp[i].getValue());
			}
		}
		
	}catch(e) {
		if (throwExceptions) {
			throw e;
		}else {
			console.error(e);
		}
	}

	return namedResources;
};

SemwidgQL._currentModel = null

SemwidgQL.getCurrentModel = function() {
	if (!SemwidgQL._currentModel) {
		SemwidgQL._currentModel = new SemwidgQL.Sparql.Model();
	}
	return SemwidgQL._currentModel;
};

SemwidgQL.setCurrentModel = function(currentModel) {
	SemwidgQL._currentModel = currentModel;
};

SemwidgQL.Prefix = function(prefix, url) {
	this.prefix = prefix;
	this.url = url;
};

SemwidgQL.Prefix.prototype.getPrefix = function() {
	return this.prefix;
};

SemwidgQL.Prefix.prototype.setPrefix = function(prefix) {
	this.prefix = prefix;
};

SemwidgQL.Prefix.prototype.getUrl = function() {
	return this.url;
};

SemwidgQL.Prefix.prototype.setUrl = function(url) {
	this.url = url;
};

SemwidgQL.NamedResource = function(name, value) {
	this.name = name;
	this.value = value;
};

SemwidgQL.NamedResource.prototype.getName = function() {
	return this.name;
};

SemwidgQL.NamedResource.prototype.setName = function(name) {
	this.name = name;
};

SemwidgQL.NamedResource.prototype.getValue = function() {
	return this.value;
};

SemwidgQL.NamedResource.prototype.setValue = function(value) {
	this.value = value;
};


